<?php 

	register_rest_route( 'alfa/v1', '/get-content/(?P<id>.+)', [
		'methods'  => 'GET',
		'callback' => 'alfa_get_contents_field',
		'permission_callback' => '__return_true',
		'args' => array(
			'id' => array(
			'default'           => null,          
			'required'          => true,          
			)
		)
	] );

	function getBetween($string, $start = "", $end = ""){
		if (strpos($string, $start)) { 
			$startCharCount = strpos($string, $start) + strlen($start);
			$firstSubStr = substr($string, $startCharCount, strlen($string));
			$endCharCount = strpos($firstSubStr, $end);
			if ($endCharCount == 0) {
				$endCharCount = strlen($firstSubStr);
			}
			return substr($firstSubStr, 0, $endCharCount);
		} else {
			return '';
		}
	}

	function alfa_get_contents_field( WP_REST_Request $request ){
	
		$obj = get_post((int) $request['id']);

		$fixed = getBetween($obj->post_content, 'alfa__contents-fixed', '_alfa__contents-fixed');

		$fixed = intval(preg_replace('/[^0-9]/', '', $fixed));

		//$data = preg_replace('#\s(id|class)="[^"]+"#', '', $obj->post_content);

		$output = [
			'content' => '',
			'headers'  => '',
			'fixed'  => ''
		];

		$headers = [];

		$counter = 1;

		$result = preg_replace_callback('|<h2(.*)</h2>|Uis', function($matches) use (&$headers) {

			global $counter;
			$counter++;

			$match = trim(strip_tags($matches[1]));
            $match = strstr($match, '>');
            $match = str_replace('>', '', $match);
            
             $heading = strtolower($match);
             $heading = str_replace(
                array(' ', ',', '!', '?', ':', '.','&nbsp;','(',')','¿'), 
                array('-', '','','','','','','','',''),
                $heading
             );

            $dash = (is_numeric($heading[0]) ? '_' : '' );
            
			array_push( $headers, array (
				$heading => $match
			));

			return '<h2 id="'.$dash.$heading.'>' . $matches[1] . '</h2>';
		
		}, $obj->post_content);

		$output['content'] = $result;

		$output['headers'] = $headers;

		$output['fixed'] = $fixed;
	
		return $output;

	}